
//note: redef from config.h
#define SYS_FREQ (40000000L)





void delay_half_us()
{
   int i;

	for(i=0;i<3;i++)
		asm("nop");


}


void delay_us()	//note: need to pass variable to slow it down so it is 1/2 usec
{
   int i;

	for(i=0;i<6;i++)
		asm("nop");

/*
	unsigned int tWait, tStart;

	tWait = (SYS_FREQ/2000000)*(num_usecs-1);

	WriteCoreTimer(0);


	while((ReadCoreTimer())<tWait);
*/

}


void delay_usecs(unsigned int num_usecs)	//note: need to pass variable to slow it down so it is 1/2 usec
{
	unsigned int i;

	//unsigned int tWait, tStart;

	//tWait = (SYS_FREQ/2000000)*(num_usecs-1);

	//WriteCoreTimer(0);
	//while((ReadCoreTimer())<tWait);



	for(i=0;i<num_usecs;i++)
		delay_us();



}


void delay_milliSecs(unsigned int num_msecs)	//note: need to pass variable to slow it down so it is 1/2 usec
{
	unsigned int i, val;

	//unsigned int tWait, tStart;

	//tWait = (SYS_FREQ/2000000)*(num_usecs-1);

	//WriteCoreTimer(0);
	//while((ReadCoreTimer())<tWait);

	val = num_msecs >> 1;

	for(i=0;i<val;i++)
		delay_usecs(930);



}


void reset_Time()
{
    WriteCoreTimer(0);

}


//assumes you set 	WriteCoreTimer(0);
//at start
float get_Time_us()
{
   unsigned int numTics;
   float num_usecs;

	numTics = (unsigned int)ReadCoreTimer();

//	num_usecs = numTics/((unsigned int)SYS_FREQ/((unsigned int)1*1000000);	//divide clock by pbdivider
	num_usecs = (float)numTics/20.0;	//divide clock by pbdivider

	return(num_usecs);
}


unsigned int get_Time_ms()
{
   unsigned int num_ms;
   float num_usecs;

	num_usecs = get_Time_us();

//	num_usecs = numTics/((unsigned int)SYS_FREQ/((unsigned int)1*1000000);	//divide clock by pbdivider
	num_ms = (unsigned int)(num_usecs/1000.0 + 0.5);	//divide clock by pbdivider

	return(num_ms);
}


void delay_ms(unsigned int num_msecs)	//note: need to pass variable to slow it down so it is 1/2 usec
{

	unsigned int tWait, tStart;

	tWait = (SYS_FREQ/2000)*(num_msecs);

	WriteCoreTimer(0);


	while((ReadCoreTimer())<tWait);

}



