//PID Controller.h


//void PID_Compute();
//float PID_Compute(float Input, float Setpoint, float outMin, float outMax, float kp, float ki, float kd, float *ITerm, float *lastInput);
void PID_Compute(float Input, float Setpoint, float outMin, float outMax, float kp, float ki, float kd, float *ITerm, float *lastInput, float *Output);


//void PID_SetTunings(double Kp, double Ki, double Kd);
void PID_SetTunings(int SampleTime_ms, float *Kp, float *Ki, float *Kd, int controllerDirection);


//void PID_Initialize();
void PID_Initialize(float Input, float *lastInput, float Output, float *ITerm, float outMax, float outMin);


//void PID_SetMode(int Mode);
//void PID_SetSampleTime(int NewSampleTime);
//void PID_SetOutputLimits(double Min, double Max);
//void PID_SetControllerDirection(int Direction);
