#include <plib.h>

#include "max31855.h";


unsigned char b0, b1, b2, b3;

int tVal;


//VOUT = (41.276FV/NC) x (TR - TAMB)

int MAX31855_Read(int chan)
{

    //THERMO_CS = 0;
    if(chan == 6)
    {
        mPORTBClearBits(BIT_6);
    }
    else if(chan == 7)
    {
        mPORTBClearBits(BIT_7);
    }

    delay_us(10);

  //Delay_us(1);

    SPI1BUF = 0x02;
    while(!SPI1STATbits.SPIRBF);
    delay_us(1);
    b0 = SPI1BUF;   //read b31-b24

    delay_us(10);	//delay is req'd when going slow, may not need it at full speed; will need to check with scope



    SPI1BUF = 0x02;
    while(!SPI1STATbits.SPIRBF);
    delay_us(1);
    b1 = SPI1BUF;   //read b23-b16

    delay_us(10);	//delay is req'd when going slow, may not need it at full speed; will need to check with scope


  //next bytes are reference temperature

    SPI1BUF = 0x02;
    while(!SPI1STATbits.SPIRBF);

    b2 = SPI1BUF;   //read b15-b8

    delay_us(10);	//delay is req'd when going slow, may not need it at full speed; will need to check with scope



    SPI1BUF = 0x02;
    while(!SPI1STATbits.SPIRBF);

    b3 = SPI1BUF;   //read b0-b7


    

    //THERMO_CS = 1;
    mPORTBSetBits(BIT_6);
    mPORTBSetBits(BIT_7);



  tVal = (unsigned long)b2<<8;
  tVal += (((unsigned long)b3));

  tVal = tVal >> 8;  //should now be internal temperature



  tVal = (unsigned long)b0<<8;
  tVal += (((unsigned long)b1));

  tVal = tVal >> 4;  //should now be thermo-couple temperature


  //error (due to noise???) suggests we need to correct by
  //by following
  if(b0&BIT_7)
  {
    //  tVal = tVal - 4096 + 170;
      //tVal = (tVal - 4096) + (tVal - 4096)/32  + 168;
  }
  else
  {
      //tVal = tVal + 175;
    //  tVal = tVal + tVal>>5 + 168;  //temp = 1.0368*tVal+168.55
  }


  //tVal ++;
  //tVal = 1333;
  return((int)tVal);



}





//Thermo click:

/*  code from mikroC

sbit THERMO_CS at LATA4_bit;


unsigned short byte[4] = {0, 0, 0, 0};

unsigned int tVal;

//VOUT = (41.276FV/NC) x (TR - TAMB)
int MAX31855_Read()
{
  THERMO_CS = 0;
  //Delay_ms(350);
  Delay_us(1);
  byte[0] = SPI_Read(0);  //read b31-b24
  byte[1] = SPI_Read(0);  //read b23-b16
  byte[2] = SPI_Read(0);  //read b15-b8
  byte[3] = SPI_Read(0);  //read b0-b7
  THERMO_CS = 1;

  tVal = (unsigned long)byte[0]<<8;
  tVal += (((unsigned long)byte[1]));

  tVal = tVal >> 4;  //should now be temperature
  tVal ++;
  //tVal = 1333;
  return((int)tVal);
}
 *
 */